try:
    from setuptools import setup, find_packages
except ImportError:
    from ez_setup import use_setuptools
    use_setuptools()
    from setuptools import setup, find_packages

setup(
    name='TrioExplorer',
    version="1.1.3",
    description='Trio: A System for Data, Uncertainty, and Lineage',
    author='Stanford InfoLab',
    author_email='triohelp@db.stanford.edu',
    url='http://infolab.stanford.edu/trio/',
    install_requires=["Trio",
                      "Beaker==1.1.2",
                      "FormEncode==1.1",
                      "pyparsing==1.5.1",
                      "Routes==1.10.1",
                      "simplejson==2.0.5",
                      "WebHelpers==0.3.4",
                      "Mako==0.2.4",
                      "Paste==1.7.2",
                      "PasteScript==1.7.2",
                      "PasteDeploy==1.3.2",
                      "Pylons==0.9.6.2",
                      "pydot==1.0.2"],
    packages=find_packages(exclude=['ez_setup']),
    include_package_data=True,
    license='BSD',
    test_suite='nose.collector',
    #package_data={'trioexplorer': ['i18n/*/LC_MESSAGES/*.mo']},
    #message_extractors = {'trioexplorer': [
    #        ('**.py', 'python', None),
    #        ('templates/**.mako', 'mako', None),
    #        ('public/**', 'ignore', None)]},
    entry_points="""
    [paste.app_factory]
    main = trioexplorer.config.middleware:make_app

    [paste.app_install]
    main = pylons.util:PylonsInstaller
    """,
)
